'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'SDK Address ported from PowerBASIC
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$NOMAIN
'$ONEXIT "VS12.BAT $FILE$ -m64 gui"
'$ONEXIT "TDMGCC.BAT $FILE$ -m64 gui"
'$ONEXIT "PEL.BAT $FILE$ -m64 gui"
'$ONEXIT "TC926_64.BAT $FILE$"
$ONEXIT "NUWENGCC.BAT $FILE$ -m64 gui"
$HEADER
	#include <windows.h>
	#include <tchar.h>
	#include <stdio.h>
	#pragma comment(lib,"kernel32.lib")
	#pragma comment(lib,"user32.lib")
	#pragma comment(lib,"gdi32.lib")
$HEADER
'==============================================================================
CONST IDD_DLG1 = 1000
CONST IDC_STC20 = 1001
CONST IDC_INDEX = 1002
CONST IDC_STC21 = 1003
CONST IDC_COMPANY = 1004
CONST IDC_STC22 = 1005
CONST IDC_LASTNAME = 1006
CONST IDC_STC23 = 1007
CONST IDC_FIRSTNAME = 1008
CONST IDC_STC24 = 1009
CONST IDC_ADDRESS1 = 1010
CONST IDC_ADDRESS2 = 1011
CONST IDC_ADDRESS3 = 1012
CONST IDC_STC25 = 1013
CONST IDC_CITYNAME = 1014
CONST IDC_STC26 = 1015
CONST IDC_STATENAME = 1016
CONST IDC_STC27 = 1017
CONST IDC_ZIPCODE = 1018
CONST IDC_STC28 = 1019
CONST IDC_COUNTRY = 1020
CONST IDC_STC29 = 1021
CONST IDC_PHONE = 1022
CONST IDC_STC30 = 1023
CONST IDC_FAX = 1024
CONST IDC_STC31 = 1025
CONST IDC_EMAIL = 1026
CONST IDC_STC32 = 1027
CONST IDC_URL = 1028
CONST IDC_STC33 = -1
CONST IDC_COMMENTS = 1029
CONST IDC_PRIOR = 1030
CONST IDC_NEXT = 1031
CONST IDC_FIND = 1032
CONST IDC_ADD = 1033
CONST IDC_UPDATE = 1034
CONST IDC_DELETE = 1035
CONST IDC_PRINT = 1036
CONST IDR_MENU1 = 10000
CONST IDM_FILE = 10001
CONST IDM_CLOSE = 10002
CONST IDM_HELP = 10003
CONST IDM_HELP2 = 10004
CONST IDM_ABOUT = 10005
CONST IDD_DLG2 =1100
CONST IDC_STC1 =1101
CONST IDC_BTN1 =1102

CONST WM_APPLYFOCUS = WM_USER + 999
CONST GBUF_SIZE = 100
'==============================================================================
Type AddressType
    Company[64]   	As TCHAR
    LastName[32]  	AS TCHAR
    FirstName[32] 	AS TCHAR
    Address1[64]  	AS TCHAR
    Address2[64]  	AS TCHAR
    Address3[64]  	AS TCHAR
    CityName[24]  	AS TCHAR
    StateName[4]  	AS TCHAR 
    ZipCode[12]   	AS TCHAR
    Country       	AS LONG
    Phone[24]     	AS TCHAR
    Fax[24]       	AS TCHAR
    Email[64]     	AS TCHAR
    Url[64]       	AS TCHAR
    Comments [1024] AS TCHAR	
End Type
'==============================================================================
Type Prop
    usefont        As dword
    hinstance      As HINSTANCE
    isrecmodified  As long
    isfilemodified As long
    currententry   As long
    maxentries     As long
    findtext[MAX_PATH]       As TCHAR	
End Type
'==============================================================================
GLOBAL gP As Prop

GLOBAL  As wchar_t gBuf[GBUF_SIZE] 

GLOBAL As AddressType Ptr gAddressBook
'==============================================================================
Sub AddCountries( hCmbo As HWND)
	Local As int i
	While _tcslen(CountryNames[i])
		SendMessage(hCmbo,CB_ADDSTRING,0,CountryNames[i])
		i++
	Wend
End Sub
'==============================================================================
Function FileSize(szFileSpec As TCHAR Ptr) As Dword
	Local fd As WIN32_FIND_DATA
	Local As DWORD nRet
	Local As HANDLE hFind
	hFind = FindFirstFile(szFileSpec,&fd)
	If hFind <> INVALID_HANDLE_VALUE Then
		FindClose(hFind)
		nRet = fd.nFileSizeLow
	End If
	Function = nRet
End Function
'==============================================================================
Sub SetButtonStatus(hWnd As HWND)
    '// If any current text is modified, make the ADD & Update buttons active
    If gP.isrecmodified Then
        EnableWindow(GetDlgItem(hWnd, IDC_ADD), TRUE)
        EnableWindow(GetDlgItem(hWnd, IDC_UPDATE), TRUE)
    Else
        EnableWindow(GetDlgItem(hWnd, IDC_ADD), FALSE)
        EnableWindow(GetDlgItem(hWnd, IDC_UPDATE),FALSE)
    End If
    '// Update the Index control text
    memset(gBuf,0,GBUF_SIZE)
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$REMS
'this works with TinyCC926 64    no buffer size here ????
$ifdef __TINYC__
	swprintf(gBuf, L"%ld%ls%ld", gP.currententry,L" /",gP.maxentries)
$else
'this needed for all other compilers VC++,PellesC,TDM-GCC,NUWEN
	swprintf(gBuf, GBUF_SIZE,L"%ld%ls%ld", gP.currententry,L" /",gP.maxentries)
$endif
$REMS
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*	
	SetWindowText(GetDlgItem(hWnd, IDC_INDEX), gBuf)
    '// Do we have any records? is not, disable the Prior/Next buttons, etc
    If gP.maxentries Then
        '// If there are records, allow the Find/Delete buttons
        EnableWindow(GetDlgItem(hWnd, IDC_FIND), TRUE)
        EnableWindow(GetDlgItem(hWnd, IDC_DELETE), TRUE)
		'zTrace(GetWStr(gP.currententry))
        '// We have records, so set the Prior button status according to the current index position
        If gP.currententry < 2 then
            EnableWindow(GetDlgItem(hWnd, IDC_PRIOR), FALSE)
        Else
            EnableWindow(GetDlgItem(hWnd, IDC_PRIOR), TRUE)
        End If
        '// Update the Next control button
        If gP.currententry >= gP.maxentries Then
            EnableWindow(GetDlgItem(hWnd, IDC_NEXT), FALSE)
        Else
            EnableWindow(GetDlgItem(hWnd, IDC_NEXT), TRUE)
        End If
    Else
        EnableWindow(GetDlgItem(hWnd, IDC_PRIOR), FALSE)
        EnableWindow(GetDlgItem(hWnd, IDC_NEXT), FALSE)
        EnableWindow(GetDlgItem(hWnd, IDC_FIND), FALSE)
        EnableWindow(GetDlgItem(hWnd, IDC_DELETE), FALSE)
    end if
End Sub
'==============================================================================
Sub UdtToDialog( hWnd As HWND,Index As Long)
	Local As AddressType Temp
	Local As Long SaveState
	Temp = gAddressBook[Index]

    '// When we change the edit control data, we generate EN_UPDATE messages...
    '// Due to the design of our GUI interface, we would end up with the ADD and UPDATE
    '// buttons becoming enabled just because we loaded a new UDT record into the dialog.
    '// to overcome this, we set the "modified" flag to %TRUE, so the main callback
    '// function ingores the "update" notication messages.

    SaveState = gP.isrecmodified
    gP.isrecmodified = TRUE

    SetWindowText(GetDlgItem(hWnd, IDC_COMPANY),   Temp.Company)
    SetWindowText(GetDlgItem(hWnd, IDC_LASTNAME),  Temp.LastName)
    SetWindowText(GetDlgItem(hWnd, IDC_FIRSTNAME), Temp.FirstName)
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS1),  Temp.Address1)
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS2),  Temp.Address2)
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS3),  Temp.Address3)
    SetWindowText(GetDlgItem(hWnd, IDC_CITYNAME),  Temp.CityName)
    SetWindowText(GetDlgItem(hWnd, IDC_STATENAME), Temp.StateName)
    SetWindowText(GetDlgItem(hWnd, IDC_ZIPCODE),   Temp.ZipCode)
    SendMessage  (GetDlgItem(hWnd, IDC_COUNTRY),   CB_SETCURSEL, Temp.Country - 1, 0)
    SetWindowText(GetDlgItem(hWnd, IDC_PHONE),     Temp.Phone)
    SetWindowText(GetDlgItem(hWnd, IDC_FAX),       Temp.Fax)
    SetWindowText(GetDlgItem(hWnd, IDC_EMAIL),     Temp.Email)
    SetWindowText(GetDlgItem(hWnd, IDC_URL),       Temp.Url)
    SetWindowText(GetDlgItem(hWnd, IDC_COMMENTS),  Temp.Comments)

    '// Restore the previous state
    gP.isrecmodified = SaveState
	
End Sub
'==============================================================================
Sub DialogToUdt(hWnd As HWND, Index As Long)
	Local Temp As AddressType
	If Index => 0 And Index < 100 Then
        Temp = gAddressBook[Index]
        GetWindowText(GetDlgItem(hWnd, IDC_COMPANY), Temp.Company, sizeof(Temp.Company))
        GetWindowText(GetDlgItem(hWnd, IDC_LASTNAME), Temp.LastName, sizeof(Temp.LastName))
        GetWindowText(GetDlgItem(hWnd, IDC_FIRSTNAME), Temp.FirstName, sizeof(Temp.FirstName))
        GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS1), Temp.Address1, sizeof(Temp.Address1))
        GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS2), Temp.Address2, sizeof(Temp.Address2))
        GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS3), Temp.Address3, sizeof(Temp.Address3))
        GetWindowText(GetDlgItem(hWnd, IDC_CITYNAME), Temp.CityName, sizeof(Temp.CityName))
        GetWindowText(GetDlgItem(hWnd, IDC_STATENAME), Temp.StateName, sizeof(Temp.StateName))
        GetWindowText(GetDlgItem(hWnd, IDC_ZIPCODE), Temp.ZipCode, sizeof(Temp.ZipCode))
        Temp.Country = SendMessage(GetDlgItem(hWnd, IDC_COUNTRY), CB_GETCURSEL, 0, 0) + 1
        GetWindowText(GetDlgItem(hWnd, IDC_PHONE), Temp.Phone, sizeof(Temp.Phone))
        GetWindowText(GetDlgItem(hWnd, IDC_FAX), Temp.Fax, sizeof(Temp.Fax))
        GetWindowText(GetDlgItem(hWnd, IDC_EMAIL), Temp.Email, sizeof(Temp.Email))
        GetWindowText(GetDlgItem(hWnd, IDC_URL), Temp.Url, sizeof(Temp.Url))
        GetWindowText(GetDlgItem(hWnd, IDC_COMMENTS), Temp.Comments, sizeof(Temp.Comments))

        gAddressBook[Index] = Temp
	End If
End Sub
'==============================================================================
Function WinMain()
	Local As WNDCLASSEX wce
	Local As HWND hMainWin 
	Local As MSG Msg
	Raw As TCHAR szFileName[]=L"ADDRESSW.DAT"
	Local As DWORD BufferSize, ByttesReaded, BytesWritten
	Raw As HANDLE hFile
	Raw As AddressType Ptr AddBookPtr
	Raw As int BookSize
	Raw As TCHAR ClassName[]= L"SDKADDRESS"
'==============================================================================
	wce.cbSize = sizeof(wce)
	wce.style           = CS_HREDRAW|CS_VREDRAW
	wce.cbWndExtra 		= DLGWINDOWEXTRA
	wce.hInstance       = hInst
	wce.lpszClassName   = ClassName
	wce.lpfnWndProc     = WndProc
	wce.hIcon         	= LoadIcon(hInst,IDI_WINLOGO)
	wce.hCursor         = LoadCursor( NULL, IDC_ARROW )
	wce.hbrBackground   = (HBRUSH) (COLOR_BTNFACE+1)

	If NOT RegisterClassEx(&wce) Then
		MessageBox(0,L"Register Class PROBLEM",L"ERROR",MB_OK)
		Function = 0
	End If	
	

	hMainWin = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_DLG1),0,0,0)
	If hMainWin = 0 Then
		MessageBox(0,L"Creation PROBLEM",L"ERROR",MB_OK)
		Function = 0
	End If

			
	
	BookSize = SizeOf(AddressType)

	gP.hinstance = hInst
	BufferSize = FileSize(szFileName)
	If BufferSize Then
        gP.currententry = 1
        gP.maxentries = BufferSize / sizeof(AddressType)
    End If
	gAddressBook = malloc((gP.maxentries+1)*BookSize)        
	AddBookPtr = gAddressBook
	AddBookPtr++
	
	hFile = CreateFile(szFileName, GENERIC_READ, 0, byval NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)
	If hFile <> INVALID_HANDLE_VALUE Then
		ReadFile(hFile, AddBookPtr, BufferSize, &ByttesReaded, NULL)
		CloseHandle(hFile)
	End If
	

	AddCountries(GetDlgItem(hMainWin,IDC_COUNTRY))
	UdtToDialog(hMainWin, gP.currententry)
	
    While GetMessage(&Msg,NULL, 0, 0)
	    If (IsDialogMessage(hMainWin, &Msg) = 0) Then
	        TranslateMessage(&Msg)
	        DispatchMessage(&Msg)
	    End If
	Wend
	'free triggers Use_DynamicA 
	cfree(gAddressBook)
	Function = Msg.wParam
End Function
'==============================================================================
CALLBACK Function WndProc()
	
	static hFocus As HWND
	_switch(CBMSG)
	BeginBlock
		_case WM_NCACTIVATE
			If CBWPARAM = 0 Then
				hFocus = GetFocus()
			End If
			break
		_case WM_SETFOCUS 
	         '// Post a message to set the focus later, since some
	         '// Windows actions can steal it if we set it here
	         if hFocus then
	            PostMessage(CBHWND, WM_APPLYFOCUS,(WPARAM) hFocus, 0)
	            hFocus = 0
	         end if
			break
		_case WM_APPLYFOCUS
	        '// Set the focus
        	If CBWPARAM Then 
        		SetFocus((HWND)wParam)
        	End If
         	Exit Function
			break
		_case WM_DESTROY
			PostQuitMessage(0)
			Function = 0
			break
		_case WM_COMMAND
			If CBCTLMSG = EN_UPDATE OR (CBCTL = IDC_COUNTRY AND CBCTLMSG = CBN_SELCHANGE) Then
	            If (gP.isrecmodified = 0) Then
	                gP.isrecmodified = TRUE
	                SetButtonStatus(CBHWND)
	            End If
			End If
			_switch(CBCTL)
			BeginBlock
				_case IDM_ABOUT
					DialogBox(gP.hinstance,MAKEINTRESOURCE(IDD_DLG2),CBHNDL,AboutProc)
					break
				_case IDCANCEL
					PostMessage(CBHNDL,WM_CLOSE,0,0)
					Exit Function
					break
				_case IDC_PRIOR
					gP.currententry = MAX(gP.currententry - 1, 1)
					'// Disregard any existing editing if one of these button clicked
					gP.isrecmodified = %FALSE
					'// Update the dialog
					UdtToDialog(hWnd, gP.currententry)
					'// Update the Prior/Next control button status
					SetButtonStatus(hWnd)
					exit function
				_case IDC_NEXT
					gP.currententry = MIN(gP.currententry + 1, gP.maxentries)
					
					'// Disregard any existing editing if one of these button clicked
					gP.isrecmodified = FALSE
					'// Update the dialog
					UdtToDialog(hWnd, gP.currententry)
					'// Update the Prior/Next control button status
					SetButtonStatus(hWnd)
					exit function
					
			EndBlock	
	EndBlock
End Function
'==============================================================================
DlgCallBack AboutProc()
	
	_switch(CBMSG)
	BeginBlock
		_case WM_CLOSE
			EndDialog(CBHWND,0)
			break
		_case WM_COMMAND
			If CBCTL = IDC_BTN1 Then
				SendMessage(CBHNDL,WM_CLOSE,0,0)
			End If
			break			
	EndBlock
End Function
'==============================================================================

SHAREDSET CountryNames[] As const TCHAR Ptr
     L"United States",L"Afghanistan",L"Albania",L"Algeria",L"Andorra",L"Angola",L"Anguilla", 
    L"Antarctica",L"Argentina",L"Armenia",L"Aruba",L"Australia",L"Austria", 
    L"Azerbaijan",L"Bahamas",L"Bahrain",L"Bangladesh",L"Barbados",L"Belarus",
    L"Belgium",L"Belize",L"Benin",L"Bermuda",L"Bhutan",L"Bolivia",L"Botswana",
    L"Bouvet Island",L"BosniaHerzogovina",L"Brazil",L"Brunei",L"Bulgaria",
    L"Burkina Faso",L"Cambodia",L"Cameroon",L"Canada",L"Cape Verde",
    L"Cayman Islands",L"Central African Rep",L"Chad",L"Chile",L"China",
    L"Christmas Island",L"Colombia",L"Comoros",L"Congo",L"Cook Islands",
    L"Costa Rica",L"Croatia",L"Cuba",L"Cyprus",L"Czech Republic",L"Denmark",
    L"Djibouti",L"Dominica",L"Dominican Republic",L"East Timor",L"Ecuador",
    L"Egypt",L"El Salvador",L"Equatorial Guinea",L"Eritrea",L"Estonia",
    L"Ethiopia",L"Falkland Islands",L"Faroe Islands",L"Fiji",L"Finland",
    L"France",L"France Metropolitan",L"French Guiana",L"French Polynesia",
    L"French S. Territories",L"Gabon",L"Gambia",L"Georgia",L"Germany",L"Ghana",
    L"Gibraltar",L"Greece",L"Greenland",L"Grenada",L"Guadeloupe",L"Guam",
    L"Guatemala",L"Guinea",L"Guinea-Bissau",L"Guyana",L"Haiti",L"Honduras",
    L"Hong Kong",L"Hungary",L"Iceland",L"IN India",L"Indonesia",L"Iran",L"Iraq",
    L"Ireland",L"Israel",L"Italy",L"Ivory Coast",L"Jamaica",L"Japan",L"Jordan",
    L"Kazakhstan",L"Kenya",L"Kiribati",L"Korea (North)",L"Korea (South)",
    L"Kuwait",L"Kyrgyzstan",L"Laos",L"Latvia",L"Lebanon",L"Lesotho",L"Liberia",
    L"Libya",L"Liechtenstein",L"Lithuania",L"Luxembourg",L"Macau",L"Macedonia",
    L"Madagascar",L"Malawi",L"Malaysia",L"Maldives",L"Mali",L"Malta",
    L"Marshall Islands",L"Martinique",L"Mauritania",L"Mauritius",L"Mayotte",
    L"Mexico",L"Micronesia",L"Miquelon",L"Moldova",L"Monaco",L"Mongolia",L"Montserrat",
    L"Morocco",L"Mozambique",L"Myanmar",L"Namibia",L"Nauru",L"Nepal",
    L"Netherlands",L"Nevis",L"New Caledonia",L"New Guinea",L"New Zealand",
    L"Nicaragua",L"Niger",L"Nigeria",L"Niue",L"Norfolk Island",L"Norway",
    L"Oman",L"Pakistan",L"Palau",L"Panama",L"Paraguay",L"Peru",L"Philippines",
    L"Pitcairn",L"Poland",L"Portugal",L"Principe",L"Puerto Rico",L"Qatar",
    L"Reunion",L"Romania",L"Russian Federation",L"Rwanda",L"Saint Kitts",
    L"Saint Lucia",L"Samoa",L"San Marino",L"Sao Tome",L"Saudi Arabia",L"Senegal",
    L"Seychelles",L"Sierra Leone",L"Singapore",L"Slovak Republic",L"Slovenia",
    L"Solomon Islands",L"Somalia",L"South Africa",L"Spain",L"Sri Lanka",
    L"St. Helena",L"St. Pierre",L"Sudan",L"Suriname",L"Swaziland",L"Sweden",
    L"Switzerland",L"Syria",L"Taiwan",L"Tajikistan",L"Tanzania",L"Thailand",
    L"Tobago",L"Togo",L"Tokelau",L"Tonga",L"Trinidad",L"Tunisia",L"Turkey",
    L"Turkmenistan",L"Tuvalu",L"Uganda",L"Ukraine",L"United Arab Emirates",
    L"United Kingdom",L"United States",L"Uruguay",L"Uzbekistan",L"Vanuatu",
    L"Vatican City State",L"Venezuela",L"Viet Nam",L"Virgin Islands (BR)",
    L"Virgin Islands (US)",L"Western Sahara",L"Yemen",L"Yugoslavia",L"Zaire",
    L"Zambia",L"Zimbabwe",L"Other",L""
END SET
'==============================================================================
